package com.hai.blx.service.impl;

import com.hai.blx.service.BlxCarService;
import com.hai.dao.BlxCarInfoMapper;
import com.hai.entity.BlxCarInfo;
import com.hai.entity.BlxCarInfoExample;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Service("blxCarService")
public class BlxCarServiceImpl implements BlxCarService {

    @Resource
    private BlxCarInfoMapper blxCarInfoMapper;

    @Override
    public void insertCar(BlxCarInfo carInfo) {
        blxCarInfoMapper.insert(carInfo);
    }

    @Override
    public void updateCar(BlxCarInfo carInfo) {
        blxCarInfoMapper.updateByPrimaryKey(carInfo);
    }

    @Override
    public List<BlxCarInfo> getCarInfoList(Map<String, Object> map) {
        BlxCarInfoExample example = new BlxCarInfoExample();
        BlxCarInfoExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getString(map, "carNo") != null) {
            criteria.andCarNoEqualTo(MapUtils.getString(map, "carNo"));
        }
        if (MapUtils.getInteger(map, "carNoType") != null) {
            criteria.andCarNoTypeEqualTo(MapUtils.getInteger(map, "carNoType") );
        }
        if (MapUtils.getLong(map, "userId") != null) {
            criteria.andUserIdEqualTo(MapUtils.getLong(map, "userId") );
        }
        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status") );
        } else {
            criteria.andStatusEqualTo(1);
        }

        return blxCarInfoMapper.selectByExample(example);
    }

    @Override
    public BlxCarInfo findCarInfoByMap(Map<String, Object> map) {

        BlxCarInfoExample example = new BlxCarInfoExample();
        BlxCarInfoExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getString(map, "carNo") != null) {
            criteria.andCarNoEqualTo(MapUtils.getString(map, "carNo"));
        }
        if (MapUtils.getInteger(map, "carNoType") != null) {
            criteria.andCarNoTypeEqualTo(MapUtils.getInteger(map, "carNoType") );
        }
        if (MapUtils.getLong(map, "userId") != null) {
            criteria.andUserIdEqualTo(MapUtils.getLong(map, "userId") );
        }
        if (MapUtils.getLong(map, "id") != null) {
            criteria.andIdEqualTo(MapUtils.getLong(map, "id") );
        }
        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status") );
        }

        List<BlxCarInfo> list = blxCarInfoMapper.selectByExample(example);

        if (list.size() > 0) {
            return list.get(0);
        }

        return null;
    }

    @Override
    public BlxCarInfo findCarInfoById(Long id) {
        return blxCarInfoMapper.selectByPrimaryKey(id);
    }
}
