package com.hai.dao;

import com.hai.entity.ApiKfcStores;
import com.hai.entity.ApiKfcStoresExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface ApiKfcStoresMapper extends ApiKfcStoresMapperExt {
    @SelectProvider(type=ApiKfcStoresSqlProvider.class, method="countByExample")
    long countByExample(ApiKfcStoresExample example);

    @DeleteProvider(type=ApiKfcStoresSqlProvider.class, method="deleteByExample")
    int deleteByExample(ApiKfcStoresExample example);

    @Delete({
        "delete from api_kfc_stores",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into api_kfc_stores (city_name_first_letter, city_code, ",
        "city_name, province_name, ",
        "province_code, kfc_city_id, ",
        "kfc_city_code, store_name, ",
        "store_code, lon, ",
        "lat, address, start_time, ",
        "end_time, store_status, ",
        "shelf_status, distance, ",
        "operator_id, operator_name, ",
        "create_time, update_time, ",
        "`status`, ext_1, ext_2, ",
        "ext_3)",
        "values (#{cityNameFirstLetter,jdbcType=VARCHAR}, #{cityCode,jdbcType=VARCHAR}, ",
        "#{cityName,jdbcType=VARCHAR}, #{provinceName,jdbcType=VARCHAR}, ",
        "#{provinceCode,jdbcType=VARCHAR}, #{kfcCityId,jdbcType=INTEGER}, ",
        "#{kfcCityCode,jdbcType=VARCHAR}, #{storeName,jdbcType=VARCHAR}, ",
        "#{storeCode,jdbcType=VARCHAR}, #{lon,jdbcType=VARCHAR}, ",
        "#{lat,jdbcType=VARCHAR}, #{address,jdbcType=VARCHAR}, #{startTime,jdbcType=VARCHAR}, ",
        "#{endTime,jdbcType=VARCHAR}, #{storeStatus,jdbcType=INTEGER}, ",
        "#{shelfStatus,jdbcType=INTEGER}, #{distance,jdbcType=VARCHAR}, ",
        "#{operatorId,jdbcType=BIGINT}, #{operatorName,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(ApiKfcStores record);

    @InsertProvider(type=ApiKfcStoresSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(ApiKfcStores record);

    @SelectProvider(type=ApiKfcStoresSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="city_name_first_letter", property="cityNameFirstLetter", jdbcType=JdbcType.VARCHAR),
        @Result(column="city_code", property="cityCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="city_name", property="cityName", jdbcType=JdbcType.VARCHAR),
        @Result(column="province_name", property="provinceName", jdbcType=JdbcType.VARCHAR),
        @Result(column="province_code", property="provinceCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="kfc_city_id", property="kfcCityId", jdbcType=JdbcType.INTEGER),
        @Result(column="kfc_city_code", property="kfcCityCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_name", property="storeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_code", property="storeCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="lon", property="lon", jdbcType=JdbcType.VARCHAR),
        @Result(column="lat", property="lat", jdbcType=JdbcType.VARCHAR),
        @Result(column="address", property="address", jdbcType=JdbcType.VARCHAR),
        @Result(column="start_time", property="startTime", jdbcType=JdbcType.VARCHAR),
        @Result(column="end_time", property="endTime", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_status", property="storeStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="shelf_status", property="shelfStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="distance", property="distance", jdbcType=JdbcType.VARCHAR),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<ApiKfcStores> selectByExample(ApiKfcStoresExample example);

    @Select({
        "select",
        "id, city_name_first_letter, city_code, city_name, province_name, province_code, ",
        "kfc_city_id, kfc_city_code, store_name, store_code, lon, lat, address, start_time, ",
        "end_time, store_status, shelf_status, distance, operator_id, operator_name, ",
        "create_time, update_time, `status`, ext_1, ext_2, ext_3",
        "from api_kfc_stores",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="city_name_first_letter", property="cityNameFirstLetter", jdbcType=JdbcType.VARCHAR),
        @Result(column="city_code", property="cityCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="city_name", property="cityName", jdbcType=JdbcType.VARCHAR),
        @Result(column="province_name", property="provinceName", jdbcType=JdbcType.VARCHAR),
        @Result(column="province_code", property="provinceCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="kfc_city_id", property="kfcCityId", jdbcType=JdbcType.INTEGER),
        @Result(column="kfc_city_code", property="kfcCityCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_name", property="storeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_code", property="storeCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="lon", property="lon", jdbcType=JdbcType.VARCHAR),
        @Result(column="lat", property="lat", jdbcType=JdbcType.VARCHAR),
        @Result(column="address", property="address", jdbcType=JdbcType.VARCHAR),
        @Result(column="start_time", property="startTime", jdbcType=JdbcType.VARCHAR),
        @Result(column="end_time", property="endTime", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_status", property="storeStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="shelf_status", property="shelfStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="distance", property="distance", jdbcType=JdbcType.VARCHAR),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    ApiKfcStores selectByPrimaryKey(Long id);

    @UpdateProvider(type=ApiKfcStoresSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") ApiKfcStores record, @Param("example") ApiKfcStoresExample example);

    @UpdateProvider(type=ApiKfcStoresSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") ApiKfcStores record, @Param("example") ApiKfcStoresExample example);

    @UpdateProvider(type=ApiKfcStoresSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(ApiKfcStores record);

    @Update({
        "update api_kfc_stores",
        "set city_name_first_letter = #{cityNameFirstLetter,jdbcType=VARCHAR},",
          "city_code = #{cityCode,jdbcType=VARCHAR},",
          "city_name = #{cityName,jdbcType=VARCHAR},",
          "province_name = #{provinceName,jdbcType=VARCHAR},",
          "province_code = #{provinceCode,jdbcType=VARCHAR},",
          "kfc_city_id = #{kfcCityId,jdbcType=INTEGER},",
          "kfc_city_code = #{kfcCityCode,jdbcType=VARCHAR},",
          "store_name = #{storeName,jdbcType=VARCHAR},",
          "store_code = #{storeCode,jdbcType=VARCHAR},",
          "lon = #{lon,jdbcType=VARCHAR},",
          "lat = #{lat,jdbcType=VARCHAR},",
          "address = #{address,jdbcType=VARCHAR},",
          "start_time = #{startTime,jdbcType=VARCHAR},",
          "end_time = #{endTime,jdbcType=VARCHAR},",
          "store_status = #{storeStatus,jdbcType=INTEGER},",
          "shelf_status = #{shelfStatus,jdbcType=INTEGER},",
          "distance = #{distance,jdbcType=VARCHAR},",
          "operator_id = #{operatorId,jdbcType=BIGINT},",
          "operator_name = #{operatorName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(ApiKfcStores record);
}