package com.hai.dao;

import com.hai.entity.BsTripartiteReqLog;
import com.hai.entity.BsTripartiteReqLogExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsTripartiteReqLogMapper extends BsTripartiteReqLogMapperExt {
    @SelectProvider(type=BsTripartiteReqLogSqlProvider.class, method="countByExample")
    long countByExample(BsTripartiteReqLogExample example);

    @DeleteProvider(type=BsTripartiteReqLogSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsTripartiteReqLogExample example);

    @Delete({
        "delete from bs_tripartite_req_log",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_tripartite_req_log (log_type, log_type_name, ",
        "log_serial_no, request_type, ",
        "request_url, request_content, ",
        "create_time, ext_1, ",
        "ext_2, ext_3, response_content)",
        "values (#{logType,jdbcType=INTEGER}, #{logTypeName,jdbcType=VARCHAR}, ",
        "#{logSerialNo,jdbcType=VARCHAR}, #{requestType,jdbcType=INTEGER}, ",
        "#{requestUrl,jdbcType=VARCHAR}, #{requestContent,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR}, #{responseContent,jdbcType=LONGVARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsTripartiteReqLog record);

    @InsertProvider(type=BsTripartiteReqLogSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsTripartiteReqLog record);

    @SelectProvider(type=BsTripartiteReqLogSqlProvider.class, method="selectByExampleWithBLOBs")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="log_type", property="logType", jdbcType=JdbcType.INTEGER),
        @Result(column="log_type_name", property="logTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="log_serial_no", property="logSerialNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_type", property="requestType", jdbcType=JdbcType.INTEGER),
        @Result(column="request_url", property="requestUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_content", property="requestContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR),
        @Result(column="response_content", property="responseContent", jdbcType=JdbcType.LONGVARCHAR)
    })
    List<BsTripartiteReqLog> selectByExampleWithBLOBs(BsTripartiteReqLogExample example);

    @SelectProvider(type=BsTripartiteReqLogSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="log_type", property="logType", jdbcType=JdbcType.INTEGER),
        @Result(column="log_type_name", property="logTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="log_serial_no", property="logSerialNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_type", property="requestType", jdbcType=JdbcType.INTEGER),
        @Result(column="request_url", property="requestUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_content", property="requestContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsTripartiteReqLog> selectByExample(BsTripartiteReqLogExample example);

    @Select({
        "select",
        "id, log_type, log_type_name, log_serial_no, request_type, request_url, request_content, ",
        "create_time, ext_1, ext_2, ext_3, response_content",
        "from bs_tripartite_req_log",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="log_type", property="logType", jdbcType=JdbcType.INTEGER),
        @Result(column="log_type_name", property="logTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="log_serial_no", property="logSerialNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_type", property="requestType", jdbcType=JdbcType.INTEGER),
        @Result(column="request_url", property="requestUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_content", property="requestContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR),
        @Result(column="response_content", property="responseContent", jdbcType=JdbcType.LONGVARCHAR)
    })
    BsTripartiteReqLog selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsTripartiteReqLogSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsTripartiteReqLog record, @Param("example") BsTripartiteReqLogExample example);

    @UpdateProvider(type=BsTripartiteReqLogSqlProvider.class, method="updateByExampleWithBLOBs")
    int updateByExampleWithBLOBs(@Param("record") BsTripartiteReqLog record, @Param("example") BsTripartiteReqLogExample example);

    @UpdateProvider(type=BsTripartiteReqLogSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsTripartiteReqLog record, @Param("example") BsTripartiteReqLogExample example);

    @UpdateProvider(type=BsTripartiteReqLogSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsTripartiteReqLog record);

    @Update({
        "update bs_tripartite_req_log",
        "set log_type = #{logType,jdbcType=INTEGER},",
          "log_type_name = #{logTypeName,jdbcType=VARCHAR},",
          "log_serial_no = #{logSerialNo,jdbcType=VARCHAR},",
          "request_type = #{requestType,jdbcType=INTEGER},",
          "request_url = #{requestUrl,jdbcType=VARCHAR},",
          "request_content = #{requestContent,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR},",
          "response_content = #{responseContent,jdbcType=LONGVARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKeyWithBLOBs(BsTripartiteReqLog record);

    @Update({
        "update bs_tripartite_req_log",
        "set log_type = #{logType,jdbcType=INTEGER},",
          "log_type_name = #{logTypeName,jdbcType=VARCHAR},",
          "log_serial_no = #{logSerialNo,jdbcType=VARCHAR},",
          "request_type = #{requestType,jdbcType=INTEGER},",
          "request_url = #{requestUrl,jdbcType=VARCHAR},",
          "request_content = #{requestContent,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsTripartiteReqLog record);
}