package com.hai.service.impl;

import com.hai.dao.HighOilCardOrderMapper;
import com.hai.entity.HighOilCardOrder;
import com.hai.entity.HighOilCardOrderExample;
import com.hai.service.HighOilCardOrderService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service("highOilCardOrderService")
public class HighOilCardOrderServiceImpl implements HighOilCardOrderService {

    @Resource
    private HighOilCardOrderMapper highOilCardOrderMapper;

    @Override
    public void insertOilCardOrder(HighOilCardOrder highOilCardOrder) {
        highOilCardOrderMapper.insert(highOilCardOrder);
    }

    @Override
    public void updateOilCardOrder(HighOilCardOrder highOilCardOrder) {
        highOilCardOrderMapper.updateByPrimaryKey(highOilCardOrder);
    }

    @Override
    public HighOilCardOrder findOrder(String orderNo) {
        HighOilCardOrderExample example = new HighOilCardOrderExample();
        HighOilCardOrderExample.Criteria criteria = example.createCriteria();

        criteria.andOrderNoEqualTo(orderNo);

        List<HighOilCardOrder> list = highOilCardOrderMapper.selectByExample(example);

        if (list.size() > 0) {
            return list.get(0);
        }

        return null;
    }
}
